import { Firewall } from './firewall';
import { MultipleStorage } from './storages/multiple.storage';
import { Options } from './interfaces/module.options';
import { PolicyInterface, Action, ActionObject, Resource, ResourceObject, Principal, PrincipalObject } from './interfaces/policy';
import { CoreHelper } from './helpers/core';
import { Entity } from './decorators/entity';
export declare class CoreService extends CoreHelper {
    private readonly options;
    firewall: Firewall;
    storage: MultipleStorage;
    constructor(options: Options);
    attach(rawPrincipal: Principal | PrincipalObject | Entity | object, rawPolicies?: Array<string | PolicyInterface>): Promise<number>;
    reset(rawPrincipal: Principal | PrincipalObject | Entity | object, rawPolicies?: Array<string | PolicyInterface>): Promise<number>;
    retrieve(rawPrincipal: Principal | PrincipalObject | Entity | object): Promise<Array<PolicyInterface>>;
    isGranted(rawAction: Action | ActionObject, rawPrincipal: Principal | PrincipalObject | Entity | object, rawResource?: Resource | ResourceObject | Entity | object, rule?: string): Promise<boolean>;
}
